Loading...
Searching...
No Matches
pcl::SampleConsensusModelCircle3D< PointT > Class Template Reference
Module sample_consensus

SampleConsensusModelCircle3D defines a model for 3D circle segmentation. More...

`#include <pcl/sample_consensus/sac_model_circle3d.h>`

Inheritance diagram for pcl::SampleConsensusModelCircle3D< PointT >:

## Public Types

using | PointCloud = typename SampleConsensusModel< PointT >::PointCloud
using | PointCloudPtr = typename SampleConsensusModel< PointT >::PointCloudPtr
using | PointCloudConstPtr = typename SampleConsensusModel< PointT >::PointCloudConstPtr
using | Ptr = shared_ptr< SampleConsensusModelCircle3D< PointT > >
using | ConstPtr = shared_ptr< const SampleConsensusModelCircle3D< PointT > >
Public Types inherited from pcl::SampleConsensusModel< PointT >
using | PointCloud = pcl::PointCloud< PointT >
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointCloudPtr = typename PointCloud::Ptr
using | SearchPtr = typename pcl::search::Search< PointT >::Ptr
using | Ptr = shared_ptr< SampleConsensusModel< PointT > >
using | ConstPtr = shared_ptr< const SampleConsensusModel< PointT > >

## Public Member Functions

| SampleConsensusModelCircle3D (const PointCloudConstPtr &cloud, bool random=false)
| Constructor for base SampleConsensusModelCircle3D.
| SampleConsensusModelCircle3D (const PointCloudConstPtr &cloud, const Indices &indices, bool random=false)
| Constructor for base SampleConsensusModelCircle3D.
| ~SampleConsensusModelCircle3D () override=default
| Empty destructor.
| SampleConsensusModelCircle3D (const SampleConsensusModelCircle3D &source)
| Copy constructor.
SampleConsensusModelCircle3D & | operator= (const SampleConsensusModelCircle3D &source)
| Copy constructor.
bool | computeModelCoefficients (const Indices &samples, Eigen::VectorXf &model_coefficients) const override
| Check whether the given index samples can form a valid 2D circle model, compute the model coefficients from these samples and store them in model_coefficients.
void | getDistancesToModel (const Eigen::VectorXf &model_coefficients, std::vector< double > &distances) const override
| Compute all distances from the cloud data to a given 3D circle model.
void | selectWithinDistance (const Eigen::VectorXf &model_coefficients, const double threshold, Indices &inliers) override
| Compute all distances from the cloud data to a given 3D circle model.
std::size_t | countWithinDistance (const Eigen::VectorXf &model_coefficients, const double threshold) const override
| Count all the points which respect the given model coefficients as inliers.
void | optimizeModelCoefficients (const Indices &inliers, const Eigen::VectorXf &model_coefficients, Eigen::VectorXf &optimized_coefficients) const override
| Recompute the 3d circle coefficients using the given inlier set and return them to the user.
void | projectPoints (const Indices &inliers, const Eigen::VectorXf &model_coefficients, PointCloud &projected_points, bool copy_data_fields=true) const override
| Create a new point cloud with inliers projected onto the 3d circle model.
bool | doSamplesVerifyModel (const std::set< index_t > &indices, const Eigen::VectorXf &model_coefficients, const double threshold) const override
| Verify whether a subset of indices verifies the given 3d circle model coefficients.
pcl::SacModel | getModelType () const override
| Return a unique id for this model (SACMODEL_CIRCLE3D).
Public Member Functions inherited from pcl::SampleConsensusModel< PointT >
| SampleConsensusModel (const PointCloudConstPtr &cloud, bool random=false)
| Constructor for base SampleConsensusModel.
| SampleConsensusModel (const PointCloudConstPtr &cloud, const Indices &indices, bool random=false)
| Constructor for base SampleConsensusModel.
virtual | ~SampleConsensusModel ()=default
| Destructor for base SampleConsensusModel.
virtual void | getSamples (int &iterations, Indices &samples)
| Get a set of random data samples and return them as point indices.
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset.
PointCloudConstPtr | getInputCloud () const
| Get a pointer to the input point cloud dataset.
void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
void | setIndices (const Indices &indices)
| Provide the vector of indices that represents the input data.
IndicesPtr | getIndices () const
| Get a pointer to the vector of indices used.
const std::string & | getClassName () const
| Get a string representation of the name of this class.
unsigned int | getSampleSize () const
| Return the size of a sample from which the model is computed.
unsigned int | getModelSize () const
| Return the number of coefficients in the model.
void | setRadiusLimits (const double &min_radius, const double &max_radius)
| Set the minimum and maximum allowable radius limits for the model (applicable to models that estimate a radius)
void | getRadiusLimits (double &min_radius, double &max_radius) const
| Get the minimum and maximum allowable radius limits for the model as set by the user.
void | setModelConstraints (std::function< bool(const Eigen::VectorXf &)> function)
| This can be used to impose any kind of constraint on the model, e.g.
void | setSamplesMaxDist (const double &radius, SearchPtr search)
| Set the maximum distance allowed when drawing random samples.
void | getSamplesMaxDist (double &radius) const
| Get maximum distance allowed when drawing random samples.
double | computeVariance (const std::vector< double > &error_sqr_dists) const
| Compute the variance of the errors to the model.
double | computeVariance () const
| Compute the variance of the errors to the model from the internally estimated vector of distances.

## Protected Member Functions

bool | isModelValid (const Eigen::VectorXf &model_coefficients) const override
| Check whether a model is valid given the user constraints.
bool | isSampleGood (const Indices &samples) const override
| Check if a sample of indices results in a good sample of points indices.
Protected Member Functions inherited from pcl::SampleConsensusModel< PointT >
| SampleConsensusModel (bool random=false)
| Empty constructor for base SampleConsensusModel.
void | drawIndexSample (Indices &sample)
| Fills a sample array with random samples from the indices_ vector.
void | drawIndexSampleRadius (Indices &sample)
| Fills a sample array with one random sample from the indices_ vector and other random samples that are closer than samples_radius_.
int | rnd ()
| Boost-based random number generator.

## Additional Inherited Members

Protected Attributes inherited from pcl::SampleConsensusModel< PointT >
std::string | model_name_
| The model name.
PointCloudConstPtr | input_
| A boost shared pointer to the point cloud data array.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
double | radius_min_
| The minimum and maximum radius limits for the model.
double | radius_max_
double | samples_radius_
| The maximum distance of subsequent samples from the first (radius search)
SearchPtr | samples_radius_search_
| The search object for picking subsequent samples using radius search.
Indices | shuffled_indices_
| Data containing a shuffled version of the indices.
boost::mt19937 | rng_alg_
| Boost-based random number generator algorithm.
std::shared_ptr< boost::uniform_int<> > | rng_dist_
| Boost-based random number generator distribution.
std::shared_ptr< boost::variate_generator< boost::mt19937 &, boost::uniform_int<> > > | rng_gen_
| Boost-based random number generator.
std::vector< double > | error_sqr_dists_
| A vector holding the distances to the computed model.
unsigned int | sample_size_
| The size of a sample from which the model is computed.
unsigned int | model_size_
| The number of coefficients in the model.
std::function< bool(const Eigen::VectorXf &)> | custom_model_constraints_
| A user defined function that takes model coefficients and returns whether the model is acceptable or not.
Static Protected Attributes inherited from pcl::SampleConsensusModel< PointT >
static const unsigned int | max_sample_checks_ = 1000
| The maximum number of samples to try until we get a good one.

## Detailed Description

template<typename PointT>
class pcl::SampleConsensusModelCircle3D< PointT >

SampleConsensusModelCircle3D defines a model for 3D circle segmentation.

The model coefficients are defined as:

- center.x : the X coordinate of the circle's center
- center.y : the Y coordinate of the circle's center
- center.z : the Z coordinate of the circle's center
- radius : the circle's radius
- normal.x : the X coordinate of the normal's direction
- normal.y : the Y coordinate of the normal's direction
- normal.z : the Z coordinate of the normal's direction

Author
  Raoul Hoffmann, Karol Hausman, Radu B. Rusu

Definition at line 60 of file sac_model_circle3d.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointT >

using pcl::SampleConsensusModelCircle3D< PointT >::ConstPtr = shared_ptr<const SampleConsensusModelCircle3D<PointT> >

Definition at line 74 of file sac_model_circle3d.h.

## PointCloud

template<typename PointT >

using pcl::SampleConsensusModelCircle3D< PointT >::PointCloud = typename SampleConsensusModel<PointT>::PointCloud

Definition at line 69 of file sac_model_circle3d.h.

## PointCloudConstPtr

template<typename PointT >

using pcl::SampleConsensusModelCircle3D< PointT >::PointCloudConstPtr = typename SampleConsensusModel<PointT>::PointCloudConstPtr

Definition at line 71 of file sac_model_circle3d.h.

## PointCloudPtr

template<typename PointT >

using pcl::SampleConsensusModelCircle3D< PointT >::PointCloudPtr = typename SampleConsensusModel<PointT>::PointCloudPtr

Definition at line 70 of file sac_model_circle3d.h.

## Ptr

template<typename PointT >

using pcl::SampleConsensusModelCircle3D< PointT >::Ptr = shared_ptr<SampleConsensusModelCircle3D<PointT> >

Definition at line 73 of file sac_model_circle3d.h.

## Constructor & Destructor Documentation

## SampleConsensusModelCircle3D() [1/3]

template<typename PointT >

pcl::SampleConsensusModelCircle3D< PointT >::SampleConsensusModelCircle3D | ( | const PointCloudConstPtr & | cloud,
|  | bool | random = `false`
| ) |  |

inline

Constructor for base SampleConsensusModelCircle3D.

Parameters

  [in] | cloud | the input point cloud dataset
  [in] | random | if true set the random seed to the current time, else set to 12345 (default: false)

Definition at line 80 of file sac_model_circle3d.h.

References pcl::SampleConsensusModel< PointT >::model_name_, pcl::SampleConsensusModel< PointT >::model_size_, and pcl::SampleConsensusModel< PointT >::sample_size_.

## SampleConsensusModelCircle3D() [2/3]

template<typename PointT >

pcl::SampleConsensusModelCircle3D< PointT >::SampleConsensusModelCircle3D | ( | const PointCloudConstPtr & | cloud,
|  | const Indices & | indices,
|  | bool | random = `false`
| ) |  |

inline

Constructor for base SampleConsensusModelCircle3D.

Parameters

  [in] | cloud | the input point cloud dataset
  [in] | indices | a vector of point indices to be used from cloud
  [in] | random | if true set the random seed to the current time, else set to 12345 (default: false)

Definition at line 94 of file sac_model_circle3d.h.

References pcl::SampleConsensusModel< PointT >::model_name_, pcl::SampleConsensusModel< PointT >::model_size_, and pcl::SampleConsensusModel< PointT >::sample_size_.

## ~SampleConsensusModelCircle3D()

template<typename PointT >

pcl::SampleConsensusModelCircle3D< PointT >::~SampleConsensusModelCircle3D | ( |  | ) |

override default

Empty destructor.

## SampleConsensusModelCircle3D() [3/3]

template<typename PointT >

pcl::SampleConsensusModelCircle3D< PointT >::SampleConsensusModelCircle3D | ( | const SampleConsensusModelCircle3D< PointT > & | source | ) |

inline

Copy constructor.

Parameters

  [in] | source | the model to copy into this

Definition at line 110 of file sac_model_circle3d.h.

References pcl::SampleConsensusModel< PointT >::model_name_.

## Member Function Documentation

## computeModelCoefficients()

template<typename PointT >

bool pcl::SampleConsensusModelCircle3D< PointT >::computeModelCoefficients | ( | const Indices & | samples,
|  | Eigen::VectorXf & | model_coefficients
| ) |  | const

override virtual

Check whether the given index samples can form a valid 2D circle model, compute the model coefficients from these samples and store them in model_coefficients.

The circle coefficients are: x, y, R.

Parameters

  [in] | samples | the point indices found as possible good candidates for creating a valid model
  [out] | model_coefficients | the resultant model coefficients

Implements pcl::SampleConsensusModel< PointT >.

Definition at line 79 of file sac_model_circle3d.hpp.

## countWithinDistance()

template<typename PointT >

std::size_t pcl::SampleConsensusModelCircle3D< PointT >::countWithinDistance | ( | const Eigen::VectorXf & | model_coefficients,
|  | const double | threshold
| ) |  | const

override virtual

Count all the points which respect the given model coefficients as inliers.

Parameters

  [in] | model_coefficients | the coefficients of a model that we need to compute distances to
  [in] | threshold | maximum admissible distance threshold for determining the inliers from the outliers

Returns
  the resultant number of inliers

Implements pcl::SampleConsensusModel< PointT >.

Definition at line 234 of file sac_model_circle3d.hpp.

References pcl::K.

## doSamplesVerifyModel()

template<typename PointT >

bool pcl::SampleConsensusModelCircle3D< PointT >::doSamplesVerifyModel | ( | const std::set< index_t > & | indices,
|  | const Eigen::VectorXf & | model_coefficients,
|  | const double | threshold
| ) |  | const

override virtual

Verify whether a subset of indices verifies the given 3d circle model coefficients.

Parameters

  [in] | indices | the data indices that need to be tested against the 3d circle model
  [in] | model_coefficients | the 3d circle model coefficients
  [in] | threshold | a maximum admissible distance threshold for determining the inliers from the outliers

Implements pcl::SampleConsensusModel< PointT >.

Definition at line 414 of file sac_model_circle3d.hpp.

References pcl::K.

## getDistancesToModel()

template<typename PointT >

void pcl::SampleConsensusModelCircle3D< PointT >::getDistancesToModel | ( | const Eigen::VectorXf & | model_coefficients,
|  | std::vector< double > & | distances
| ) |  | const

override virtual

Compute all distances from the cloud data to a given 3D circle model.

Parameters

  [in] | model_coefficients | the coefficients of a 2D circle model that we need to compute distances to
  [out] | distances | the resultant estimated distances

Implements pcl::SampleConsensusModel< PointT >.

Definition at line 139 of file sac_model_circle3d.hpp.

## getModelType()

template<typename PointT >

pcl::SacModel pcl::SampleConsensusModelCircle3D< PointT >::getModelType | ( |  | ) | const

inline override virtual

Return a unique id for this model (SACMODEL_CIRCLE3D).

Implements pcl::SampleConsensusModel< PointT >.

Definition at line 199 of file sac_model_circle3d.h.

References pcl::SACMODEL_CIRCLE3D.

## isModelValid()

template<typename PointT >

bool pcl::SampleConsensusModelCircle3D< PointT >::isModelValid | ( | const Eigen::VectorXf & | model_coefficients | ) | const

override protected virtual

Check whether a model is valid given the user constraints.

Parameters

  [in] | model_coefficients | the set of model coefficients

Reimplemented from pcl::SampleConsensusModel< PointT >.

Definition at line 460 of file sac_model_circle3d.hpp.

## isSampleGood()

template<typename PointT >

bool pcl::SampleConsensusModelCircle3D< PointT >::isSampleGood | ( | const Indices & | samples | ) | const

override protected virtual

Check if a sample of indices results in a good sample of points indices.

Parameters

  [in] | samples | the resultant index samples

Implements pcl::SampleConsensusModel< PointT >.

Definition at line 50 of file sac_model_circle3d.hpp.

## operator=()

template<typename PointT >

SampleConsensusModelCircle3D & pcl::SampleConsensusModelCircle3D< PointT >::operator= | ( | const SampleConsensusModelCircle3D< PointT > & | source | ) |

inline

Copy constructor.

Parameters

  [in] | source | the model to copy into this

Definition at line 121 of file sac_model_circle3d.h.

## optimizeModelCoefficients()

template<typename PointT >

void pcl::SampleConsensusModelCircle3D< PointT >::optimizeModelCoefficients | ( | const Indices & | inliers,
|  | const Eigen::VectorXf & | model_coefficients,
|  | Eigen::VectorXf & | optimized_coefficients
| ) |  | const

override virtual

Recompute the 3d circle coefficients using the given inlier set and return them to the user.

Note
  : these are the coefficients of the 3d circle model after refinement (e.g. after SVD)

Parameters

  [in] | inliers | the data inliers found as supporting the model
  [in] | model_coefficients | the initial guess for the optimization
  [out] | optimized_coefficients | the resultant recomputed coefficients after non-linear optimization

Implements pcl::SampleConsensusModel< PointT >.

Definition at line 276 of file sac_model_circle3d.hpp.

## projectPoints()

template<typename PointT >

void pcl::SampleConsensusModelCircle3D< PointT >::projectPoints | ( | const Indices & | inliers,
|  | const Eigen::VectorXf & | model_coefficients,
|  | PointCloud & | projected_points,
|  | bool | copy_data_fields = `true`
| ) |  | const

override virtual

Create a new point cloud with inliers projected onto the 3d circle model.

Parameters

  [in] | inliers | the data inliers that we want to project on the 3d circle model
  [in] | model_coefficients | the coefficients of a 3d circle model
  [out] | projected_points | the resultant projected points
  [in] | copy_data_fields | set to true if we need to copy the other data fields

Implements pcl::SampleConsensusModel< PointT >.

Definition at line 312 of file sac_model_circle3d.hpp.

References pcl::K.

## selectWithinDistance()

template<typename PointT >

void pcl::SampleConsensusModelCircle3D< PointT >::selectWithinDistance | ( | const Eigen::VectorXf & | model_coefficients,
|  | const double | threshold,
|  | Indices & | inliers
| ) |  |

override virtual

Compute all distances from the cloud data to a given 3D circle model.

Parameters

  [in] | model_coefficients | the coefficients of a 3D circle model that we need to compute distances to
  [in] | threshold | a maximum admissible distance threshold for determining the inliers from the outliers
  [out] | inliers | the resultant model inliers

Implements pcl::SampleConsensusModel< PointT >.

Definition at line 186 of file sac_model_circle3d.hpp.

The documentation for this class was generated from the following files:

- pcl/sample_consensus/sac_model_circle3d.h
- pcl/sample_consensus/impl/sac_model_circle3d.hpp